= nng_http_client_set_tls(3http)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_http_client_set_tls - set HTTP client TLS configuration

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/http/http.h>

int nng_http_client_set_tls(nng_http_client *client, nng_tls_config *cfg);
----

== DESCRIPTION

The `nng_http_client_set_tls()` sets the TLS configuration of _client_ to _cfg_.

This change overwrites any previous TLS configuration.

IMPORTANT: This also invalidates any previously obtained values from
xref:nng_http_client_get_tls.3http.adoc[`nng_http_client_get_tls()`].

NOTE: Any connections established with
xref:nng_http_client_connect.3http.adoc[`nng_http_client_connect()`]
will continue to use any TLS configuration that they were started with.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory exists.
`NNG_ENOTSUP`:: Either HTTP or TLS not supported.

== SEE ALSO

[.text-left]
xref:nng_http_client_alloc.3http.adoc[nng_http_client_alloc(3http)],
xref:nng_http_client_connect.3http.adoc[nng_http_client_connect(3http)],
xref:nng_http_client_get_tls.3http.adoc[nng_http_client_get_tls(3http)],
xref:nng_tls_config_alloc.3tls.adoc[nng_tls_config_alloc(3tls)],
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng.7.adoc[nng(7)]
